#! /bin/bash


function scurl {
  curl -s -g -w '%{http_code}' -H Expect: -H "X-Auth-Token: $TOKEN" -X "$@"
}

if [ -z $1 ] || [ -z $2 ] || [ -z $3 ]; then
  usage
else
  LOGIN=`curl --dump-header - -s -H "X-Auth-User: $1" \
         -H "X-Auth-Key: $2" "https://auth.api.rackspacecloud.com/v1.0"`
  TOKEN=`echo "$LOGIN" | grep ^X-Auth-Token | sed 's/.*: //' | tr -d "\r\n"`
  URL=`echo "$LOGIN" | grep ^X-Server-Management-Url | sed 's/.*: //' | tr -d "\r\n"`

  if [ -z $TOKEN ] || [ -z $URL ]; then
    echo "Unable to auth."
    exit 1
  fi
  case $3 in
    GET)
      OBJNAME=`basename "$4"`
      CODE=`scurl GET "$URL/servers"`
	  echo $CODE
      ;;
    POST)
      TYPE="application/json"
      OBJNAME=`basename "$4"`
	  
	  OBJNAME_CONT=`cat "$OBJNAME"`		  
      CODE=`scurl POST -H "Content-Type: $TYPE" -d "$OBJNAME_CONT" "$URL/servers/"`
	  FILE_NAME=`echo $CODE | awk '{
			split($0,a1,"name\":\"")
			split(a1[2],a2,"\"")
			print a2[1];}'`.txt
	echo $CODE >> $FILE_NAME
	./cloudfiles.sh rackcloud07 49699c210919208cba51a8f3ae3721fa PUT GigaSpaces $FILE_NAME	
	  echo $CODE
      ;;    
    esac
fi