package com.gigaspaces.ucs.service;

import org.apache.commons.lang.builder.ToStringBuilder;

/********
 * A sample event handler for the UCS system. Logs all events to a java.util.logging.Logger.
 * @author barakme.
 *
 */
public class LoggingServiceEventHandler implements UCSServiceEventHandler {

	private static java.util.logging.Logger logger = java.util.logging.Logger
	.getLogger(LoggingServiceEventHandler.class.getName());
	
	private final Service service;


	/*********
	 * Constructor.
	 * @param service the UCS service/
	 */
	public LoggingServiceEventHandler(final Service service) {
		this.service = service;

	}

	@Override
	public void channelClosed() {
		logger.info("Channel was closed - starting a new one!");
		EventRecieverRunnable.launchRecieverThread(service, this);
	}

	@Override
	public void eventRecieved(final Object event) {
		logger.info(ToStringBuilder.reflectionToString(event));

	}

}
