package com.gigaspaces.rackspace.examples;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;


import net.rubyeye.xmemcached.MemcachedClient;
import net.rubyeye.xmemcached.XMemcachedClient;
import net.rubyeye.xmemcached.exception.MemcachedException;

public class MemcacheTest {

	public static void main(final String[] args) {
		try {

			final MemcachedClient memClient = new XMemcachedClient("localhost",
					11211);

			// System.out.println("Connected to memcache "
			// +memClient.getAvailableServers());
			// testSimpleMemcached(memClient);
			MemcacheTest.testMemcachedPerformance(memClient);
			memClient.shutdown();

		} catch (final Exception ex) {

			ex.printStackTrace();
			System.exit(1);
		}
		System.exit(0);
	}

	public static void testMemcachedPerformance(final MemcachedClient memClient)
			throws InterruptedException, ExecutionException, TimeoutException,
			MemcachedException {

		long startTime = System.currentTimeMillis();
		final int iterations = 1000;
		for (int i = 0; i < iterations; i++) {
			memClient.set(Integer.toString(i), 3600 * 60, new Data(i, "message"
					+ i, null));
		}

		long endTime = System.currentTimeMillis();
		double optime = (double) (endTime - startTime) / iterations;
		System.out.println("Total memClient.set time: " + (endTime - startTime)
				+ "ms " + "optime=" + optime + " " + (long) (1000 / optime)
				+ "ops/sec");

		startTime = System.currentTimeMillis();
		for (int i = 0; i < iterations; i++) {
			memClient.get(Integer.toString(i));
		}

		endTime = System.currentTimeMillis();
		optime = (double) (endTime - startTime) / iterations;
		System.out.println("Total memClient.get time: " + (endTime - startTime)
				+ "ms " + "optime=" + optime + " " + (long) (1000 / optime)
				+ "ops/sec");
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	/*
	 * public static void main(String[] args) { try{
	 * 
	 * MemcachedClient memClient=new MemcachedClient(new
	 * InetSocketAddress("localhost", 11211));
	 * //System.out.println("Connected to memcache "
	 * +memClient.getAvailableServers()); //testSimpleMemcached(memClient);
	 * testMemcachedPerformance(memClient); memClient.shutdown();
	 * 
	 * }catch(Exception ex ){
	 * 
	 * ex.printStackTrace(); System.exit(1); }
	 * 
	 * System.exit(0);
	 * 
	 * }
	 * 
	 * public static void testSimpleMemcached(MemcachedClient memClient){
	 * 
	 * // Store a value (async) for one hour memClient.set("someKey", 3600*60,
	 * "data"); // Retrieve a value (synchronously). Object
	 * myObject=memClient.get("someKey"); }
	 * 
	 * public static void testMemcachedPerformance(MemcachedClient memClient)
	 * throws InterruptedException, ExecutionException{
	 * 
	 * long startTime = System.currentTimeMillis(); int iterations = 20000; for
	 * (int i =0; i< iterations; i++) { Future f = memClient.set(""+i, 3600*60,
	 * new Data(i,"message" + i, null)); f.get(); }
	 * 
	 * 
	 * long endTime = System.currentTimeMillis(); double optime =
	 * (double)(endTime-startTime)/iterations;
	 * System.out.println("Total memClient.set time: " + (endTime-startTime) +
	 * "ms " + "optime="+optime+" " + (long)(1000/optime) +"ops/sec" ); }
	 */

}
